Attribute VB_Name = "modTaskIcon"
' -------------------------------------------------------
' |   Author:    Christian Gruber (gruber.chri@gmx.at)  |
' |                                                     |
' |   Funktion:  ermglicht das Deaktivieren            |
' |              des Task-Managers (unter WinXP/2000)   |
' -------------------------------------------------------

Option Explicit

Private Type TrayData
    hWnd As Long
    id As Long
End Type

Private Type TBButton
    iBitmap As Long
    idCommand As Long
    fsState As Byte
    fsStyle As Byte
    bReserved(0 To 1) As Byte
    dwData As Long
    iString As Long
End Type

Private Type NOTIFYICONDATA
   cbSize As Long
   hWnd As Long
   uId As Long
   uFlags As Long
   uCallbackMessage As Long
   hIcon As Long
   szTip As String * 128
   dwState As Long
   dwStateMask As Long
   szInfo As String * 256
   uTimeoutAndVersion As Long
   szInfoTitle As String * 64
   dwInfoFlags As Long
End Type

Private Declare Function FindWindow Lib "user32" _
    Alias "FindWindowA" (ByVal lpClassName As String, _
    ByVal lpWindowName As String) As Long
        
Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" _
    (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, _
    lParam As Any) As Long

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" _
    (ByVal hWnd1 As Long, ByVal hWnd2 As Long, _
    ByVal lpsz1 As String, ByVal lpsz2 As String) As Long

Private Declare Function GetWindowThreadProcessId Lib "user32.dll" ( _
    ByVal hWnd As Long, lpdwProcessId As Long) As Long

Private Declare Function OpenProcess Lib "kernel32.dll" ( _
    ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, _
    ByVal dwProcessId As Long) As Long

Private Declare Function VirtualAllocEx Lib "kernel32.dll" ( _
    ByVal hProcess As Long, lpAddress As Any, _
    ByRef dwSize As Long, ByVal flAllocationType As Long, _
    ByVal flProtect As Long) As Long

Private Declare Function SendMessage Lib "user32.dll" Alias _
    "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, _
    ByVal wParam As Long, lParam As Any) As Long

Private Declare Function ReadProcessMemory Lib "kernel32.dll" ( _
    ByVal hProcess As Long, lpBaseAddress As Any, _
    lpBuffer As Any, ByVal nSize As Long, _
    lpNumberOfBytesWritten As Long) As Long

Private Declare Function GetWindowTextLength Lib "user32" _
    Alias "GetWindowTextLengthA" (ByVal hWnd As Long) As Long
        
Private Declare Function GetWindowText Lib "user32" Alias _
    "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString _
    As String, ByVal cch As Long) As Long

Private Declare Function Shell_NotifyIcon Lib "shell32" Alias _
    "Shell_NotifyIconA" (ByVal dwMessage As Long, pnid As _
    NOTIFYICONDATA) As Boolean
                
Private Declare Function VirtualFreeEx Lib "kernel32.dll" ( _
    ByVal hProcess As Long, lpAddress As Any, _
    ByRef dwSize As Long, ByVal dwFreeType As Long) As Long

Private Declare Function CloseHandle Lib "kernel32" ( _
    ByVal hObject As Long) As Long

Private Declare Function GetSystemDirectory Lib "kernel32" _
    Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, _
    ByVal nSize As Long) As Long
 
 
Const WM_CLOSE = &H10
Const STANDARD_RIGHTS_REQUIRED As Long = &HF0000
Const SYNCHRONIZE As Long = &H100000
Const PROCESS_ALL_ACCESS As Long = (STANDARD_RIGHTS_REQUIRED Or SYNCHRONIZE Or &HFFF)
Const MEM_COMMIT As Long = &H1000
Const PAGE_READWRITE As Long = &H4
Const WM_USER As Long = &H400
Const TB_BUTTONCOUNT As Long = (WM_USER + 24)
Const TB_GETBUTTON As Long = (WM_USER + 23)
Const NIS_HIDDEN = &H1
Const NIF_STATE = &H8
Const NIM_MODIFY As Long = &H1&
Const MEM_RELEASE As Long = &H8000
Const kLength = 255&

Private TIcon As NOTIFYICONDATA


Private Sub killTaskManager()
    Dim hWndTask As Long
    hWndTask = FindWindow(vbNullString, "Windows Task-Manager")
    If hWndTask <> 0 Then
        PostMessage hWndTask, WM_CLOSE, ByVal 0&, ByVal 0&
    End If
    
End Sub


Private Sub taskManagerIconVisible(bVisible As Boolean)
    Dim hWndTray As Long
    Dim hProc As Long
    Dim pid As Long
    Dim vaPtr As Long
    Dim ret As Long
    Dim tbut As TBButton
    Dim cButtons As Long
    Dim td As TrayData
    Dim i As Long
    Dim Result As Long
    Dim Title As String

    
    hWndTray = FindWindowEx(ByVal 0&, ByVal 0&, "Shell_TrayWnd", vbNullString)
    hWndTray = FindWindowEx(hWndTray, ByVal 0&, "TrayNotifyWnd", vbNullString)
    hWndTray = FindWindowEx(hWndTray, ByVal 0&, "SysPager", vbNullString)
    hWndTray = FindWindowEx(hWndTray, ByVal 0&, "ToolbarWindow32", vbNullString)
    
    If hWndTray = 0 Then Exit Sub
    
    Call GetWindowThreadProcessId(hWndTray, pid)
    If pid = 0 Then Exit Sub
    
    hProc = OpenProcess(PROCESS_ALL_ACCESS, 0, pid)
    If hProc = 0 Then Exit Sub
    
    vaPtr = VirtualAllocEx(hProc, ByVal 0&, Len(tbut), MEM_COMMIT, PAGE_READWRITE)
    If vaPtr = 0 Then GoTo cleanup
    
    cButtons = SendMessage(hWndTray, TB_BUTTONCOUNT, ByVal 0&, ByVal 0&)
    
    On Error GoTo cleanup
    
    For i = 0 To cButtons - 1
        Call SendMessage(hWndTray, TB_GETBUTTON, i, ByVal vaPtr)
        Call ReadProcessMemory(hProc, ByVal vaPtr, tbut, Len(tbut), ret)
        
        If Not tbut.dwData = 0 Then
            Call ReadProcessMemory(hProc, ByVal tbut.dwData, td, Len(td), ret)
    
            Result = GetWindowTextLength(td.hWnd) + 1
            Title = Space$(Result)
            Result = GetWindowText(td.hWnd, Title, Result)
            Title = Left$(Title, Len(Title) - 1)
            
            If Title = "Windows Task-Manager" And td.id = 0 Then ' es gibt viele versteckte TrayIcons vom Task-Manager, nur das mit der ID 0 ist fr uns von Interesse
                TIcon.cbSize = Len(TIcon)
                TIcon.hWnd = td.hWnd
                TIcon.uId = td.id
                TIcon.uFlags = NIF_STATE
                TIcon.dwStateMask = NIS_HIDDEN
                If bVisible Then
                    TIcon.dwState = TIcon.dwState And Not NIS_HIDDEN
                Else
                    TIcon.dwState = TIcon.dwState Or NIS_HIDDEN
                End If
                
                Shell_NotifyIcon NIM_MODIFY, TIcon
            End If
        End If
    Next i
    
cleanup:
    If hProc Then
        If vaPtr Then
            Call VirtualFreeEx(hProc, ByVal vaPtr, 0&, MEM_RELEASE)
        End If
    End If
    If hProc Then CloseHandle (hProc)
End Sub

Public Sub disableTaskManager(bDisable As Boolean)
    If bDisable Then
        killTaskManager ' der Task-Manager knnte geffnet sein, zuerst schlieen
        Shell GetSysDir & "\taskmgr.exe", vbHide ' den Task-Manager versteckt ffnen
        Sleep 500 ' kurz warten, da es ein bisschen dauert, bis das TrayIcon des TaskManagers erscheint
        taskManagerIconVisible False  ' das TrayIcon der Task-Managers deaktivieren
    Else
        taskManagerIconVisible True ' das TrayIcon wieder sichtbar machen - ist eigentlich nicht unbedingt notwendig
        killTaskManager ' Task-Manager schlieen
    End If
    
End Sub

Private Function GetSysDir() As String
  Dim nBuffer As String
  Dim nReturn As Long

  nBuffer = Space(kLength)
  nReturn = GetSystemDirectory(nBuffer, kLength)
  If nReturn > 0 Then
      GetSysDir = Left(nBuffer, nReturn)
  End If
End Function
